%add_verify_elf_skiplist %_libdir/libshocker.so

%define with_managed desktop
%def_with ffmpeg
%def_with alsa
%def_with pulseaudio

Name: moon
Version: 1.0
Release: alt1

Summary: Open Source implementation of Silverlight
License: LGPLv2
Group: Development/Other
Url: http://www.mono-project.com/Moonlight

Source: http://ftp.novell.com/pub/mono/sources/%name/%name-%version.tar.bz2
Source2: %name-sharp.dll.config

Patch2: moon-0.8-new-ffmpeg.patch
Patch4: moon-0.8.1-alt-link.patch
Patch5: moon-1.0-alt-missing-files.patch
Patch6: moon-1.0-alt-install-include.patch
Patch8: moon-0.8.1-alt-fix-man.patch
Patch9: moon-0.8.1-alt-monodoc.patch

BuildPreReq: xulrunner-devel >= 1.9
BuildPreReq: libcairo-devel >= 1.8
BuildPreReq: libgtk+2-devel
BuildPreReq: libXrandr-devel
BuildPreReq: libfreetype-devel fontconfig-devel
BuildPreReq: libXtst-devel >= 1.0
BuildPreReq: libImageMagick-devel >= 6.3.5
BuildPreReq: libdbus-glib-devel >= 0.60
BuildPreReq: ndesk-dbus >= 0.6.0

%if %with_managed != no
BuildPreReq: libgnome-desktop-sharp libgtk-sharp2
BuildPreReq: mono-devel >= 1.9 libmono-devel mono-data mono-mcs
%endif
%{?_with_ffmpeg:BuildPreReq: libavutil-devel libavcodec-devel}
%{?_with_alsa:BuildPreReq: libalsa-devel}
%{?_with_pulseaudio:BuildPreReq: libpulseaudio-devel}

BuildRequires: gcc-c++ libexpat-devel mono-data-postgresql ndesk-dbus xorg-inputproto-devel xorg-xextproto-devel

%description
Moonlight is an open source implementation of Microsoft Silverlight
for Unix systems. It supports rich browser applications, similar to
Adobe Flash.

%package -n lib%name
Group:System/Libraries
Summary: Open Source implementation of Silverlight

%description -n lib%name
Moonlight is an open source implementation of Microsoft Silverlight
for Unix systems. It supports rich browser applications, similar to
Adobe Flash.

%package -n lib%name-devel
Group:Development/C++
Summary: Open Source implementation of Silverlight
Requires: lib%name = %version-%release

%description -n lib%name-devel
Moonlight is an open source implementation of Microsoft Silverlight
for Unix systems. It supports rich browser applications, similar to
Adobe Flash.

%package tools
Summary: Various tools for Open Source implementation of Silverlight
Group: Development/Other
Requires: lib%name = %version-%release

%description tools
Various tools for Open Source implementation of Silverlight.
Moonlight is an open source implementation of Microsoft Silverlight
for Unix systems.

%package -n lib%name-sharp
Summary: Mono bindings for Open Source implementation of Silverlight
Group: Development/Other
Requires: lib%name = %version-%release

%description -n lib%name-sharp
Mono bindings for Open Source implementation of Silverlight.
Moonlight is an open source implementation of Microsoft Silverlight
for Unix systems.

%package -n lib%name-sharp-doc
Summary: Development documentation for Moonlight.
Group: Documentation
Provides: lib%name-sharp-monodoc = %version-%release
Obsoletes: lib%name-sharp-monodoc 
BuildPreReq: monodoc
Requires: monodoc
BuildArch: noarch

%description -n lib%name-sharp-doc
This package contains the API documentation for the Moonlight in
Monodoc format.

%package -n mozilla-plugin-moonlight
Summary: Browser plugin for Open Source implementation of Silverlight
Group: Networking/WWW
Requires: lib%name = %version-%release
Requires: browser-plugins-npapi

%description -n mozilla-plugin-moonlight
Browser plugin for Open Source implementation of Silverlight.

Moonlight is an open source implementation of Microsoft Silverlight
for Unix systems.

%package examples
Summary: Example applications Open Source implementation of Silverlight
Group: Development/Other
Requires: lib%name = %version-%release

%description examples
Example applications for Open Source implementation of Silverlight (including desklets).

Moonlight is an open source implementation of Microsoft Silverlight
for Unix systems.

%prep
%setup -q
#%patch2 -p1
##%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch8 -p1
%patch9 -p1

subst "s|^pkgconfigdir *= \$(prefix)/lib/pkgconfig|pkgconfigdir = %_pkgconfigdir|" \
	data/Makefile.am \
	gtk/Makefile.am
cp %SOURCE2 %name-sharp.dll.config
subst "s|libmoonplugin.so|%_libdir/moon/plugin/libmoonplugin.so|" %name-sharp.dll.config

subst "s|@prefix@/lib/mono/moon/gtksilver.dll|@prefix@/lib/mono/gtksilver/gtksilver.dll|" gtk/gtksilver.pc.in
# disable build examples/desklet/calculator
subst "s|calculator||" examples/desklet/Makefile.am
# install moon.pc
subst "s|noinst_DATA=moon.pc|pkgconfig_DATA = moon.pc|" Makefile.am

%build
#aclocal -I pixman -I cairo
#autoconf
#automake
rm -rf cairo
%autoreconf

#gw tests don't build
#%define _disable_ld_no_undefined 1

%configure \
	%{?_with_ffmpeg:--with-ffmpeg=yes} \
	--with-ff3=yes \
	--with-cairo=system \
	%{?_with_alsa:--with-alsa=yes} \
	%{?_with_pulseaudio:--with-pulseaudio=yes} \
	--with-managed=desktop

#	--with-managed=yes \

%make

%install
%make_install DESTDIR=%buildroot install
rm %buildroot%_libdir/libmoon.la
rm %buildroot%_libdir/moon/plugin/*.la
mkdir -p %buildroot%_libdir/browser-plugins-npapi
ln -s %_libdir/moon/plugin/libmoonloader.so %buildroot%_libdir/browser-plugins-npapi/libmoonloader.so

%if %with_managed == yes || %with_managed == desktop
# install gtksilver to gac
rm -f %buildroot%_monodir/moon/gtksilver.dll
gacutil -i gtk/gtksilver.dll -f -package gtksilver -root %buildroot/usr/lib

# install dll.config files
dll=$(find %buildroot%_monogacdir -type f -iname *.dll)
for dllconfig in $dll; do
	install -m644 %name-sharp.dll.config ${dllconfig}.config
done
%endif

%files -n lib%name
%doc AUTHORS COPYING ChangeLog README TODO NEWS
%_libdir/libmoon.so.*

%files -n lib%name-devel
%_libdir/libmoon.so
%_libdir/pkgconfig/moon.pc
%_includedir/libmoon

%files tools
%_bindir/mopen1
%if %with_managed == yes || %with_managed == desktop
%dir %_prefix/lib/moon
%_bindir/mopen
%_prefix/lib/moon/mopen.exe*
%_man1dir/mopen.1.gz
%_bindir/xamlg
%_prefix/lib/moon/xamlg.exe
%_man1dir/xamlg.1.gz
%_bindir/xaml2html
%_prefix/lib/moon/xaml2html.exe
%_bindir/mxap
%_prefix/lib/moon/mxap.exe
%_man1dir/mxap.1.gz
%_bindir/respack
%_prefix/lib/moon/respack.exe
%_man1dir/respack.1.gz
#%{_bindir}/svg2xaml 
#%{_prefix}/lib/moon/svg2xaml.exe 
%_man1dir/svg2xaml.1.gz
%endif


%if %with_managed == yes || %with_managed == desktop
%files -n lib%name-sharp
%dir %_monodir/3.0
%_monodir/3.0/*
%_monogacdir/Mono.Moonlight
%_monogacdir/System.Windows
%_monogacdir/System.Windows.Browser
%_monogacdir/gtksilver
%_monodir/gtksilver
%_pkgconfigdir/agmono.pc
%_pkgconfigdir/silver.pc
%_pkgconfigdir/silverdesktop.pc
%_pkgconfigdir/gtksilver.pc

%files -n lib%name-sharp-doc
%_monodocdir/gtksilver.*

%files examples
%_bindir/example-*
%dir %_libdir/desklets
%_libdir/desklets/example-*

%endif

%files -n mozilla-plugin-moonlight
%dir %_libdir/moon
%dir %_libdir/moon/plugin
%_libdir/moon/plugin/libmoonloader.so
%_libdir/moon/plugin/libmoonplugin.so
%_libdir/moon/plugin/libmoonplugin-*bridge.so*
%if %with_managed == yes || %with_managed == plugin
%_libdir/moon/plugin/moonlight.exe
%_monodir/2.1/*
%_monogacdir/Mono.Moonlight/2.*
%_monogacdir/System.Windows/2.*
%_monogacdir/System.Windows.Browser/2.*
%endif
%if %with_managed == plugin
%dir %_monogacdir/Mono.Moonlight
%dir %_monogacdir/System.Windows
%dir %_monogacdir/System.Windows.Browser
%endif
%_libdir/browser-plugins-npapi/libmoonloader.so
%exclude %_libdir/moon/plugin/README


# exclude tests
%exclude %_bindir/agviewer
%exclude %_libdir/libshocker.so


%changelog
* Tue Jan 20 2009 Alexey Shabalin <shaba@altlinux.ru> 1.0-alt1
- 1.0
- install gtksilver.dll to %_monodir/gtksilver

* Mon Dec 01 2008 Alexey Shabalin <shaba@altlinux.ru> 0.8.1-alt3
- rebuild with new macros _monodocdir
- remove post scripts
- rename package %name-monodoc to %name-doc

* Sat Nov 08 2008 Alexey Shabalin <shaba@altlinux.ru> 0.8.1-alt2
- fix pkgconfig path in Makefile
- install dll.config files

* Wed Nov 05 2008 Alexey Shabalin <shaba@altlinux.ru> 0.8.1-alt1
- initial build for ALTLinux (based on mandriva and opensuse spec)

